diff --git a/salt/utils/cloud.py b/salt/utils/cloud.py
index 0485a7476a..0d59aaf7db 100644
--- a/salt/utils/cloud.py
+++ b/salt/utils/cloud.py
@@ -1360,6 +1368,8 @@ def deploy_script(host,
                         salt_config_to_yaml(minion_grains),
                         ssh_kwargs
                     )
+                if cloud_grains and opts.get('enable_cloud_grains', True):
+                    minion_conf['grains'] = {'salt-cloud': cloud_grains}
                 ssh_file(
                     opts,
                     '{0}/minion'.format(tmp_dir),
@@ -1443,6 +1453,15 @@ def deploy_script(host,
                             'Can\'t set ownership for {0}'.format(
                                 preseed_minion_keys_tempdir))
 
+            # Run any pre-flight commands before running deploy scripts
+            preflight_cmds = kwargs.get('preflight_cmds', [])
+            for command in preflight_cmds:
+                cmd_ret = root_cmd(command, tty, sudo, **ssh_kwargs)
+                if cmd_ret:
+                    raise SaltCloudSystemExit(
+                        'Pre-flight command failed: \'{0}\''.format(command)
+                    )
+
             # The actual deploy script
             if script:
                 # got strange escaping issues with sudoer, going onto a
@@ -1456,7 +1475,8 @@ def deploy_script(host,
                     raise SaltCloudSystemExit(
                         'Can\'t set perms on {0}/deploy.sh'.format(tmp_dir))
 
-            newtimeout = timeout - (time.mktime(time.localtime()) - starttime)
+            time_used = time.mktime(time.localtime()) - time.mktime(starttime)
+            newtimeout = timeout - time_used
             queue = None
             process = None
             # Consider this code experimental. It causes Salt Cloud to wait
@@ -1477,6 +1497,8 @@ def deploy_script(host,
             if script:
                 if 'bootstrap-salt' in script:
                     deploy_command += ' -c \'{0}\''.format(tmp_dir)
+                    if force_minion_config:
+                        deploy_command += ' -F'
                     if make_syndic is True:
                         deploy_command += ' -S'
                     if make_master is True:
@@ -1529,13 +1551,13 @@ def deploy_script(host,
                             deploy_command
                         )
                     )
-                log.debug('Executed command \'{0}\''.format(deploy_command))
+                log.debug('Executed command \'%s\'', deploy_command)
 
                 # Remove the deploy script
                 if not keep_tmp:
                     root_cmd('rm -f \'{0}/deploy.sh\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/deploy.sh'.format(tmp_dir))
+                    log.debug('Removed %s/deploy.sh', tmp_dir)
                     if script_env:
                         root_cmd(
                             'rm -f \'{0}/environ-deploy-wrapper.sh\''.format(
@@ -1543,51 +1565,45 @@ def deploy_script(host,
                             ),
                             tty, sudo, **ssh_kwargs
                         )
-                        log.debug(
-                            'Removed {0}/environ-deploy-wrapper.sh'.format(
-                                tmp_dir
-                            )
-                        )
+                        log.debug('Removed %s/environ-deploy-wrapper.sh', tmp_dir)
 
             if keep_tmp:
-                log.debug(
-                    'Not removing deployment files from {0}/'.format(tmp_dir)
-                )
+                log.debug('Not removing deployment files from %s/', tmp_dir)
             else:
                 # Remove minion configuration
                 if minion_pub:
                     root_cmd('rm -f \'{0}/minion.pub\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/minion.pub'.format(tmp_dir))
+                    log.debug('Removed %s/minion.pub', tmp_dir)
                 if minion_pem:
                     root_cmd('rm -f \'{0}/minion.pem\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/minion.pem'.format(tmp_dir))
+                    log.debug('Removed %s/minion.pem', tmp_dir)
                 if minion_conf:
                     root_cmd('rm -f \'{0}/grains\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/grains'.format(tmp_dir))
+                    log.debug('Removed %s/grains', tmp_dir)
                     root_cmd('rm -f \'{0}/minion\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/minion'.format(tmp_dir))
+                    log.debug('Removed %s/minion', tmp_dir)
                 if master_sign_pub_file:
                     root_cmd('rm -f {0}/master_sign.pub'.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/master_sign.pub'.format(tmp_dir))
+                    log.debug('Removed %s/master_sign.pub', tmp_dir)
 
                 # Remove master configuration
                 if master_pub:
                     root_cmd('rm -f \'{0}/master.pub\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/master.pub'.format(tmp_dir))
+                    log.debug('Removed %s/master.pub', tmp_dir)
                 if master_pem:
                     root_cmd('rm -f \'{0}/master.pem\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/master.pem'.format(tmp_dir))
+                    log.debug('Removed %s/master.pem', tmp_dir)
                 if master_conf:
                     root_cmd('rm -f \'{0}/master\''.format(tmp_dir),
                              tty, sudo, **ssh_kwargs)
-                    log.debug('Removed {0}/master'.format(tmp_dir))
+                    log.debug('Removed %s/master', tmp_dir)
 
                 # Remove pre-seed keys directory
                 if preseed_minion_keys is not None:
@@ -1596,9 +1612,7 @@ def deploy_script(host,
                             preseed_minion_keys_tempdir
                         ), tty, sudo, **ssh_kwargs
                     )
-                    log.debug(
-                        'Removed {0}'.format(preseed_minion_keys_tempdir)
-                    )
+                    log.debug('Removed %s', preseed_minion_keys_tempdir)
 
             if start_action and not parallel:
                 queuereturn = queue.get()
@@ -1610,19 +1624,14 @@ def deploy_script(host,
                     # )
                     # for line in output:
                     #    print(line)
-                    log.info(
-                        'Executing {0} on the salt-minion'.format(
-                            start_action
-                        )
-                    )
+                    log.info('Executing %s on the salt-minion', start_action)
                     root_cmd(
                         'salt-call {0}'.format(start_action),
                         tty, sudo, **ssh_kwargs
                     )
                     log.info(
-                        'Finished executing {0} on the salt-minion'.format(
-                            start_action
-                        )
+                        'Finished executing %s on the salt-minion',
+                        start_action
                     )
             # Fire deploy action
             fire_event(
@@ -1674,12 +1683,12 @@ def run_inline_script(host,
         gateway = kwargs['gateway']
 
     starttime = time.mktime(time.localtime())
-    log.debug('Deploying {0} at {1}'.format(host, starttime))
+    log.debug('Deploying %s at %s', host, starttime)
 
     known_hosts_file = kwargs.get('known_hosts_file', '/dev/null')
 
     if wait_for_port(host=host, port=port, gateway=gateway):
-        log.debug('SSH port {0} on {1} is available'.format(port, host))
+        log.debug('SSH port %s on %s is available', port, host)
         newtimeout = timeout - (time.mktime(time.localtime()) - starttime)
         if wait_for_passwd(host, port=port, username=username,
                            password=password, key_filename=key_filename,
@@ -1687,11 +1696,7 @@ def run_inline_script(host,
                            display_ssh_output=display_ssh_output,
                            gateway=gateway, known_hosts_file=known_hosts_file):
 
-            log.debug(
-                'Logging into {0}:{1} as {2}'.format(
-                    host, port, username
-                )
-            )
+            log.debug('Logging into %s:%s as %s', host, port, username)
             newtimeout = timeout - (time.mktime(time.localtime()) - starttime)
             ssh_kwargs = {
                 'hostname': host,
@@ -1707,7 +1712,7 @@ def run_inline_script(host,
                 ssh_kwargs['ssh_gateway_key'] = gateway['ssh_gateway_key']
                 ssh_kwargs['ssh_gateway_user'] = gateway['ssh_gateway_user']
             if key_filename:
-                log.debug('Using {0} as the key_filename'.format(key_filename))
+                log.debug('Using %s as the key_filename', key_filename)
                 ssh_kwargs['key_filename'] = key_filename
             elif password and 'has_ssh_agent' in kwargs and kwargs['has_ssh_agent'] is False:
                 ssh_kwargs['password'] = password
@@ -1718,26 +1723,53 @@ def run_inline_script(host,
                         allow_failure=True, **ssh_kwargs) and inline_script:
                 log.debug('Found inline script to execute.')
                 for cmd_line in inline_script:
-                    log.info("Executing inline command: " + str(cmd_line))
+                    log.info('Executing inline command: %s', cmd_line)
                     ret = root_cmd('sh -c "( {0} )"'.format(cmd_line),
                                    tty, sudo, allow_failure=True, **ssh_kwargs)
                     if ret:
-                        log.info("[" + str(cmd_line) + "] Output: " + str(ret))
+                        log.info('[%s] Output: %s', cmd_line, ret)
 
     # TODO: ensure we send the correct return value
     return True
 
 
-def fire_event(key, msg, tag, args=None, sock_dir=None, transport='zeromq'):
-    # Fire deploy action
-    if sock_dir is None:
-        salt.utils.warn_until(
-            'Oxygen',
-            '`salt.utils.cloud.fire_event` requires that the `sock_dir`'
-            'parameter be passed in when calling the function.'
-        )
-        sock_dir = __opts__['sock_dir']
+def filter_event(tag, data, defaults):
+    '''
+    Accept a tag, a dict and a list of default keys to return from the dict, and
+    check them against the cloud configuration for that tag
+    '''
+    ret = {}
+    keys = []
+    use_defaults = True
 
+    for ktag in __opts__.get('filter_events', {}):
+        if tag != ktag:
+            continue
+        keys = __opts__['filter_events'][ktag]['keys']
+        use_defaults = __opts__['filter_events'][ktag].get('use_defaults', True)
+
+    if use_defaults is False:
+        defaults = []
+
+    # For PY3, if something like ".keys()" or ".values()" is used on a dictionary,
+    # it returns a dict_view and not a list like in PY2. "defaults" should be passed
+    # in with the correct data type, but don't stack-trace in case it wasn't.
+    if not isinstance(defaults, list):
+        defaults = list(defaults)
+
+    defaults = list(set(defaults + keys))
+
+    for key in defaults:
+        if key in data:
+            ret[key] = data[key]
+
+    return ret
+
+
+def fire_event(key, msg, tag, sock_dir, args=None, transport='zeromq'):
+    '''
+    Fire deploy action
+    '''
     event = salt.utils.event.get_event(
         'master',
         sock_dir,
@@ -1765,7 +1797,7 @@ def _exec_ssh_cmd(cmd, error_msg=None, allow_failure=False, **kwargs):
     password_retries = kwargs.get('password_retries', 3)
     try:
         stdout, stderr = None, None
-        proc = vt.Terminal(
+        proc = salt.utils.vt.Terminal(
             cmd,
             shell=True,
             log_stdout=True,
@@ -1782,7 +1814,7 @@ def _exec_ssh_cmd(cmd, error_msg=None, allow_failure=False, **kwargs):
                 if ('key_filename' in kwargs and kwargs['key_filename']
                     and SSH_PASSWORD_PROMP_SUDO_RE.search(stdout)
                 ):
-                    proc.sendline(kwargs['sudo_password', None])
+                    proc.sendline(kwargs['sudo_password'])
                 # elif authenticating via password and haven't exhausted our
                 # password_retires
                 elif (
@@ -1805,9 +1837,9 @@ def _exec_ssh_cmd(cmd, error_msg=None, allow_failure=False, **kwargs):
                 )
             )
         return proc.exitstatus
-    except vt.TerminalException as err:
+    except salt.utils.vt.TerminalException as err:
         trace = traceback.format_exc()
-        log.error(error_msg.format(cmd, err, trace))
+        log.error(error_msg.format(cmd, err, trace))  # pylint: disable=str-format-in-logging
     finally:
         proc.close(terminate=True, kill=True)
     # Signal an error
@@ -1831,7 +1863,7 @@ def scp_file(dest_path, contents=None, kwargs=None, local_file=None):
                     if exc.errno != errno.EBADF:
                         raise exc
 
-        log.debug('Uploading {0} to {1}'.format(dest_path, kwargs['hostname']))
+        log.debug('Uploading %s to %s', dest_path, kwargs['hostname'])
 
         ssh_args = [
             # Don't add new hosts to the host key database
@@ -1917,7 +1949,7 @@ def scp_file(dest_path, contents=None, kwargs=None, local_file=None):
             )
         )
 
-        log.debug('SCP command: \'{0}\''.format(cmd))
+        log.debug('SCP command: \'%s\'', cmd)
         retcode = _exec_ssh_cmd(cmd,
                                 error_msg='Failed to upload file \'{0}\': {1}\n{2}',
                                 password_retries=3,
@@ -1956,7 +1988,7 @@ def sftp_file(dest_path, contents=None, kwargs=None, local_file=None):
         if contents is not None:
             try:
                 tmpfd, file_to_upload = tempfile.mkstemp()
-                if isinstance(contents, str):
+                if isinstance(contents, six.string_types):
                     os.write(tmpfd, contents.encode(__salt_system_encoding__))
                 else:
                     os.write(tmpfd, contents)
@@ -1972,7 +2004,7 @@ def sftp_file(dest_path, contents=None, kwargs=None, local_file=None):
             if os.path.isdir(local_file):
                 put_args = ['-r']
 
-        log.debug('Uploading {0} to {1} (sftp)'.format(dest_path, kwargs.get('hostname')))
+        log.debug('Uploading %s to %s (sftp)', dest_path, kwargs.get('hostname'))
 
         ssh_args = [
             # Don't add new hosts to the host key database
@@ -2047,7 +2079,7 @@ def sftp_file(dest_path, contents=None, kwargs=None, local_file=None):
         cmd = 'echo "put {0} {1} {2}" | sftp {3} {4[username]}@{5}'.format(
             ' '.join(put_args), file_to_upload, dest_path, ' '.join(ssh_args), kwargs, ipaddr
         )
-        log.debug('SFTP command: \'{0}\''.format(cmd))
+        log.debug('SFTP command: \'%s\'', cmd)
         retcode = _exec_ssh_cmd(cmd,
                                 error_msg='Failed to upload file \'{0}\': {1}\n{2}',
                                 password_retries=3,
@@ -2093,13 +2125,7 @@ def win_cmd(command, **kwargs):
         proc.communicate()
         return proc.returncode
     except Exception as err:
-        log.error(
-            'Failed to execute command \'{0}\': {1}\n'.format(
-                logging_command,
-                err
-            ),
-            exc_info=True
-        )
+        log.exception('Failed to execute command \'%s\'', logging_command)
     # Signal an error
     return 1
 
@@ -2108,9 +2134,7 @@ def winrm_cmd(session, command, flags, **kwargs):
     '''
     Wrapper for commands to be run against Windows boxes using WinRM.
     '''
-    log.debug('Executing WinRM command: {0} {1}'.format(
-        command, flags
-    ))
+    log.debug('Executing WinRM command: %s %s', command, flags)
     r = session.run_cmd(command, flags)
     return r.status_code
 
@@ -2130,7 +2154,7 @@ def root_cmd(command, tty, sudo, allow_failure=False, **kwargs):
             logging_command = 'sudo -S "XXX-REDACTED-XXX" {0}'.format(command)
             command = 'sudo -S {0}'.format(command)
 
-        log.debug('Using sudo to run command {0}'.format(logging_command))
+        log.debug('Using sudo to run command %s', logging_command)
 
     ssh_args = []
 
@@ -2201,9 +2225,8 @@ def root_cmd(command, tty, sudo, allow_failure=False, **kwargs):
             )
         ])
         log.info(
-            'Using SSH gateway {0}@{1}:{2}'.format(
-                ssh_gateway_user, ssh_gateway, ssh_gateway_port
-            )
+            'Using SSH gateway %s@%s:%s',
+            ssh_gateway_user, ssh_gateway, ssh_gateway_port
         )
 
     if 'port' in kwargs:
@@ -2221,7 +2244,7 @@ def root_cmd(command, tty, sudo, allow_failure=False, **kwargs):
         logging_command = 'timeout {0} {1}'.format(hard_timeout, logging_command)
         cmd = 'timeout {0} {1}'.format(hard_timeout, cmd)
 
-    log.debug('SSH command: \'{0}\''.format(logging_command))
+    log.debug('SSH command: \'%s\'', logging_command)
 
     retcode = _exec_ssh_cmd(cmd, allow_failure=allow_failure, **kwargs)
     return retcode
@@ -2235,11 +2258,7 @@ def check_auth(name, sock_dir=None, queue=None, timeout=300):
     event = salt.utils.event.SaltEvent('master', sock_dir, listen=True)
     starttime = time.mktime(time.localtime())
     newtimeout = timeout
-    log.debug(
-        'In check_auth, waiting for {0} to become available'.format(
-            name
-        )
-    )
+    log.debug('In check_auth, waiting for %s to become available', name)
     while newtimeout > 0:
         newtimeout = timeout - (time.mktime(time.localtime()) - starttime)
         ret = event.get_event(full=True)
@@ -2248,7 +2267,7 @@ def check_auth(name, sock_dir=None, queue=None, timeout=300):
         if ret['tag'] == 'minion_start' and ret['data']['id'] == name:
             queue.put(name)
             newtimeout = 0
-            log.debug('Minion {0} is ready to receive commands'.format(name))
+            log.debug('Minion %s is ready to receive commands', name)
 
 
 def ip_to_int(ip):
@@ -2318,14 +2337,11 @@ def remove_sshkey(host, known_hosts=None):
 
     if known_hosts is not None:
         log.debug(
-            'Removing ssh key for {0} from known hosts file {1}'.format(
-                host, known_hosts
-            )
+            'Removing ssh key for %s from known hosts file %s',
+            host, known_hosts
         )
     else:
-        log.debug(
-            'Removing ssh key for {0} from known hosts file'.format(host)
-        )
+        log.debug('Removing ssh key for %s from known hosts file', host)
 
     cmd = 'ssh-keygen -R {0}'.format(host)
     subprocess.call(cmd, shell=True)
@@ -2368,18 +2384,14 @@ def wait_for_ip(update_callback,
     duration = timeout
     while True:
         log.debug(
-            'Waiting for VM IP. Giving up in 00:{0:02d}:{1:02d}.'.format(
-                int(timeout // 60),
-                int(timeout % 60)
-            )
+            'Waiting for VM IP. Giving up in 00:%02d:%02d.',
+            int(timeout // 60), int(timeout % 60)
         )
         data = update_callback(*update_args, **update_kwargs)
         if data is False:
             log.debug(
                 '\'update_callback\' has returned \'False\', which is '
-                'considered a failure. Remaining Failures: {0}.'.format(
-                    max_failures
-                )
+                'considered a failure. Remaining Failures: %s.', max_failures
             )
             max_failures -= 1
             if max_failures <= 0:
@@ -2405,7 +2417,7 @@ def wait_for_ip(update_callback,
             if interval > timeout:
                 interval = timeout + 1
             log.info('Interval multiplier in effect; interval is '
-                     'now {0}s.'.format(interval))
+                     'now %ss.', interval)
 
 
 def list_nodes_select(nodes, selection, call=None):
@@ -2430,7 +2442,7 @@ def list_nodes_select(nodes, selection, call=None):
         pairs = {}
         data = nodes[node]
         for key in data:
-            if str(key) in selection:
+            if six.text_type(key) in selection:
                 value = data[key]
                 pairs[key] = value
         ret[node] = pairs
@@ -2446,19 +2458,19 @@ def lock_file(filename, interval=.5, timeout=15):
     Note that these locks are only recognized by Salt Cloud, and not other
     programs or platforms.
     '''
-    log.trace('Attempting to obtain lock for {0}'.format(filename))
+    log.trace('Attempting to obtain lock for %s', filename)
     lock = filename + '.lock'
     start = time.time()
     while True:
         if os.path.exists(lock):
             if time.time() - start >= timeout:
-                log.warning('Unable to obtain lock for {0}'.format(filename))
+                log.warning('Unable to obtain lock for %s', filename)
                 return False
             time.sleep(interval)
         else:
             break
 
-    with salt.utils.fopen(lock, 'a'):
+    with salt.utils.files.fopen(lock, 'a'):
         pass
 
 
@@ -2469,12 +2481,12 @@ def unlock_file(filename):
     Note that these locks are only recognized by Salt Cloud, and not other
     programs or platforms.
     '''
-    log.trace('Removing lock for {0}'.format(filename))
+    log.trace('Removing lock for %s', filename)
     lock = filename + '.lock'
     try:
         os.remove(lock)
     except OSError as exc:
-        log.trace('Unable to remove lock for {0}: {1}'.format(filename, exc))
+        log.trace('Unable to remove lock for %s: %s', filename, exc)
 
 
 def cachedir_index_add(minion_id, profile, driver, provider, base=None):
@@ -2497,8 +2509,9 @@ def cachedir_index_add(minion_id, profile, driver, provider, base=None):
     lock_file(index_file)
 
     if os.path.exists(index_file):
-        with salt.utils.fopen(index_file, 'r') as fh_:
-            index = msgpack.load(fh_)
+        mode = 'rb' if six.PY3 else 'r'
+        with salt.utils.files.fopen(index_file, mode) as fh_:
+            index = salt.utils.data.decode(msgpack.load(fh_, encoding=MSGPACK_ENCODING))
     else:
         index = {}
 
@@ -2513,8 +2526,9 @@ def cachedir_index_add(minion_id, profile, driver, provider, base=None):
         }
     })
 
-    with salt.utils.fopen(index_file, 'w') as fh_:
-        msgpack.dump(index, fh_)
+    mode = 'wb' if six.PY3 else 'w'
+    with salt.utils.files.fopen(index_file, mode) as fh_:
+        msgpack.dump(index, fh_, encoding=MSGPACK_ENCODING)
 
     unlock_file(index_file)
 
@@ -2529,16 +2543,18 @@ def cachedir_index_del(minion_id, base=None):
     lock_file(index_file)
 
     if os.path.exists(index_file):
-        with salt.utils.fopen(index_file, 'r') as fh_:
-            index = msgpack.load(fh_)
+        mode = 'rb' if six.PY3 else 'r'
+        with salt.utils.files.fopen(index_file, mode) as fh_:
+            index = salt.utils.data.decode(msgpack.load(fh_, encoding=MSGPACK_ENCODING))
     else:
         return
 
     if minion_id in index:
         del index[minion_id]
 
-    with salt.utils.fopen(index_file, 'w') as fh_:
-        msgpack.dump(index, fh_)
+    mode = 'wb' if six.PY3 else 'w'
+    with salt.utils.files.fopen(index_file, mode) as fh_:
+        msgpack.dump(index, fh_, encoding=MSGPACK_ENCODING)
 
     unlock_file(index_file)
 
@@ -2582,7 +2598,7 @@ def request_minion_cachedir(
         base = __opts__['cachedir']
 
     if not fingerprint and pubkey is not None:
-        fingerprint = salt.utils.pem_finger(key=pubkey, sum_type=(opts and opts.get('hash_type') or 'sha256'))
+        fingerprint = salt.utils.crypt.pem_finger(key=pubkey, sum_type=(opts and opts.get('hash_type') or 'sha256'))
 
     init_cachedir(base)
 
@@ -2594,8 +2610,9 @@ def request_minion_cachedir(
 
     fname = '{0}.p'.format(minion_id)
     path = os.path.join(base, 'requested', fname)
-    with salt.utils.fopen(path, 'w') as fh_:
-        msgpack.dump(data, fh_)
+    mode = 'wb' if six.PY3 else 'w'
+    with salt.utils.files.fopen(path, mode) as fh_:
+        msgpack.dump(data, fh_, encoding=MSGPACK_ENCODING)
 
 
 def change_minion_cachedir(
@@ -2626,13 +2643,13 @@ def change_minion_cachedir(
     fname = '{0}.p'.format(minion_id)
     path = os.path.join(base, cachedir, fname)
 
-    with salt.utils.fopen(path, 'r') as fh_:
-        cache_data = msgpack.load(fh_)
+    with salt.utils.files.fopen(path, 'r') as fh_:
+        cache_data = salt.utils.data.decode(msgpack.load(fh_, encoding=MSGPACK_ENCODING))
 
     cache_data.update(data)
 
-    with salt.utils.fopen(path, 'w') as fh_:
-        msgpack.dump(cache_data, fh_)
+    with salt.utils.files.fopen(path, 'w') as fh_:
+        msgpack.dump(cache_data, fh_, encoding=MSGPACK_ENCODING)
 
 
 def activate_minion_cachedir(minion_id, base=None):
@@ -2669,21 +2686,23 @@ def delete_minion_cachedir(minion_id, provider, opts, base=None):
     fname = '{0}.p'.format(minion_id)
     for cachedir in 'requested', 'active':
         path = os.path.join(base, cachedir, driver, provider, fname)
-        log.debug('path: {0}'.format(path))
+        log.debug('path: %s', path)
         if os.path.exists(path):
             os.remove(path)
 
 
-def list_cache_nodes_full(opts, provider=None, base=None):
+def list_cache_nodes_full(opts=None, provider=None, base=None):
     '''
     Return a list of minion data from the cloud cache, rather from the cloud
     providers themselves. This is the cloud cache version of list_nodes_full().
     '''
+    if opts is None:
+        opts = __opts__
     if opts.get('update_cachedir', False) is False:
         return
 
     if base is None:
-        base = os.path.join(__opts__['cachedir'], 'active')
+        base = os.path.join(opts['cachedir'], 'active')
 
     minions = {}
     # First, get a list of all drivers in use
@@ -2698,12 +2717,13 @@ def list_cache_nodes_full(opts, provider=None, base=None):
             minions[driver][prov] = {}
             min_dir = os.path.join(prov_dir, prov)
             # Get a list of all nodes per provider
-            for minion_id in os.listdir(min_dir):
+            for fname in os.listdir(min_dir):
                 # Finally, get a list of full minion data
-                fname = '{0}.p'.format(minion_id)
                 fpath = os.path.join(min_dir, fname)
-                with salt.utils.fopen(fpath, 'r') as fh_:
-                    minions[driver][prov][minion_id] = msgpack.load(fh_)
+                minion_id = fname[:-2]  # strip '.p' from end of msgpack filename
+                mode = 'rb' if six.PY3 else 'r'
+                with salt.utils.files.fopen(fpath, mode) as fh_:
+                    minions[driver][prov][minion_id] = salt.utils.data.decode(msgpack.load(fh_, encoding=MSGPACK_ENCODING))
 
     return minions
 
@@ -2713,8 +2733,13 @@ def cache_nodes_ip(opts, base=None):
     Retrieve a list of all nodes from Salt Cloud cache, and any associated IP
     addresses. Returns a dict.
     '''
+    salt.utils.versions.warn_until(
+        'Flourine',
+        'This function is incomplete and non-functional '
+        'and will be removed in Salt Flourine.'
+    )
     if base is None:
-        base = __opts__['cachedir']
+        base = opts['cachedir']
 
     minions = list_cache_nodes_full(opts, base=base)
 
@@ -2759,8 +2784,8 @@ def update_bootstrap(config, url=None):
         else:
             script_name = os.path.basename(url)
     elif os.path.exists(url):
-        with salt.utils.fopen(url) as fic:
-            script_content = fic.read()
+        with salt.utils.files.fopen(url) as fic:
+            script_content = salt.utils.stringutils.to_unicode(fic.read())
         script_name = os.path.basename(url)
     # in last case, assuming we got a script content
     else:
@@ -2832,28 +2857,20 @@ def update_bootstrap(config, url=None):
             try:
                 os.makedirs(entry)
             except (OSError, IOError) as err:
-                log.info(
-                    'Failed to create directory \'{0}\''.format(entry)
-                )
+                log.info('Failed to create directory \'%s\'', entry)
                 continue
 
         if not is_writeable(entry):
-            log.debug(
-                'The \'{0}\' is not writeable. Continuing...'.format(
-                    entry
-                )
-            )
+            log.debug('The \'%s\' is not writeable. Continuing...', entry)
             continue
 
         deploy_path = os.path.join(entry, script_name)
         try:
             finished_full.append(deploy_path)
-            with salt.utils.fopen(deploy_path, 'w') as fp_:
-                fp_.write(script_content)
+            with salt.utils.files.fopen(deploy_path, 'w') as fp_:
+                fp_.write(salt.utils.stringutils.to_str(script_content))
         except (OSError, IOError) as err:
-            log.debug(
-                'Failed to write the updated script: {0}'.format(err)
-            )
+            log.debug('Failed to write the updated script: %s', err)
             continue
 
     return {'Success': {'Files updated': finished_full}}
@@ -2881,8 +2898,9 @@ def cache_node_list(nodes, provider, opts):
     for node in nodes:
         diff_node_cache(prov_dir, node, nodes[node], opts)
         path = os.path.join(prov_dir, '{0}.p'.format(node))
-        with salt.utils.fopen(path, 'w') as fh_:
-            msgpack.dump(nodes[node], fh_)
+        mode = 'wb' if six.PY3 else 'w'
+        with salt.utils.files.fopen(path, mode) as fh_:
+            msgpack.dump(nodes[node], fh_, encoding=MSGPACK_ENCODING)
 
 
 def cache_node(node, provider, opts):
@@ -2906,8 +2924,9 @@ def cache_node(node, provider, opts):
     if not os.path.exists(prov_dir):
         os.makedirs(prov_dir)
     path = os.path.join(prov_dir, '{0}.p'.format(node['name']))
-    with salt.utils.fopen(path, 'w') as fh_:
-        msgpack.dump(node, fh_)
+    mode = 'wb' if six.PY3 else 'w'
+    with salt.utils.files.fopen(path, mode) as fh_:
+        msgpack.dump(node, fh_, encoding=MSGPACK_ENCODING)
 
 
 def missing_node_cache(prov_dir, node_list, provider, opts):
@@ -2980,17 +2999,17 @@ def diff_node_cache(prov_dir, node, new_data, opts):
         )
         return
 
-    with salt.utils.fopen(path, 'r') as fh_:
+    with salt.utils.files.fopen(path, 'r') as fh_:
         try:
-            cache_data = msgpack.load(fh_)
+            cache_data = salt.utils.data.decode(msgpack.load(fh_, encoding=MSGPACK_ENCODING))
         except ValueError:
-            log.warning('Cache for {0} was corrupt: Deleting'.format(node))
+            log.warning('Cache for %s was corrupt: Deleting', node)
             cache_data = {}
 
     # Perform a simple diff between the old and the new data, and if it differs,
     # return both dicts.
     # TODO: Return an actual diff
-    diff = cmp(new_data, cache_data)
+    diff = salt.utils.compat.cmp(new_data, cache_data)
     if diff != 0:
         fire_event(
             'event',
